const EventEmitter = require('events')

StartTest(t => {

    let emitter

    t.beforeEach(() => {
        emitter     = new EventEmitter()
    })

    t.it("Testing event emitter", t => {
        // define the "events spec" for this sub test

        t.firesOk(emitter, {
            event1      : '==1',
            event2      : '>=2',
            event3      : '<3'
        })

        t.wontFire(emitter, 'event4')

        t.waitForEvent(emitter, 'event2', () => {
            t.pass("`event2` has been emitted")
        })


        // emits events
        emitter.emit('event1')

        emitter.emit('event2')
        emitter.emit('event2')

        emitter.emit('event3')
    })
})
