/*

Siesta 5.3.1
Copyright(c) 2009-2020 Bryntum AB
https://bryntum.com/contact
https://bryntum.com/products/siesta/license

*/
Ext.define('Siesta.Recorder.UI.ActionColumn', {
    extend       : 'Ext.tree.Column',
    alias        : 'widget.recorderactioncolumn',
    
    requires        : [
        'Siesta.Recorder.UI.Editor.ActionName'
    ],
    
    dataIndex    : 'action',
    width        : 100,
    sortable     : false,
    menuDisabled : true,
    tdCls        : 'siesta-recorderpanel-typecolumn',
    editor       : 'typeeditor',

    constructor : function () {
        var R       = Siesta.Resource('Siesta.Recorder.UI.RecorderPanel');
        this.text   = R.get('actionColumnHeader');

        this.callParent(arguments);
    },

    renderer : function(value, meta, record) {
        meta.tdCls = ' action-level-' + (record.parentNode.data.root ? '0' : '1');

        if (record.isLeaf()) {
            return value;
        } else {
            return record.data.name;
        }
    }
});
