import {Constructable, Mixin} from "../../../generic/util/Common.js";
import {CanLog} from "../../../generic/util/role/CanLog.js";


export const NodeJsLogger = <T extends Constructable>(base : T) => class NodeJsLogger extends CanLog<Constructable>(base) {

    printLn (message : string) {
        console.log(message)
    }
}

export type NodeJsLogger = Mixin<typeof NodeJsLogger>
