StartTest(function(t) {

    t.it('`throwsOkAsync` should correctly pass', function (t) {

        document.body.innerHTML = '<div onclick="foobar()" id="el" class="some-button">Some text</div>'

        var done

        t.chain(
            function (next) {
                done = t.throwsOkAsync('foobar', 'Correct exception thrown')
                next()
            },
            // the exception is expected from the click handler
            { click : '.some-button' },
            function (next) {
                done()
                next()
            }
        )
    })


    t.it('`throwsOkAsync` should correctly fail', function (t) {
        t.expectFail(function(t) {
            document.body.innerHTML = '<div id="el" class="some-button">Some text</div>'

            var done

            t.chain(
                function (next) {
                    done = t.throwsOkAsync('foobar', 'Correct exception thrown', 1000)
                    next()
                },
                // the exception is expected from the click handler
                { click : '.some-button' },
                function (next) {
                    done()
                    next()
                }
            )
        })
    })


    t.it('`livesOkAsync` should correctly pass', function (t) {

        document.body.innerHTML = '<div id="el" class="some-button">Some text</div>'

        var done

        t.chain(
            function (next) {
                done = t.livesOkAsync('No exception thrown')
                next()
            },
            // the exception is expected from the click handler
            { click : '.some-button' },
            function (next) {
                done()
                next()
            }
        )
    })


    t.it('`livesOkAsync` should correctly fail', function (t) {
        t.expectFail(function(t) {
            document.body.innerHTML = '<div onclick="foobar()" id="el" class="some-button">Some text</div>'

            var done

            t.chain(
                function (next) {
                    done = t.livesOkAsync('No exception thrown')
                    next()
                },
                // the exception is expected from the click handler
                { click : '.some-button' },
                function (next) {
                    done()
                    next()
                }
            )
        })
    })
})
