Ext.data.JsonP.Siesta_Recorder_Role_CanRecordMouseMovePath({"tagname":"class","name":"Siesta.Recorder.Role.CanRecordMouseMovePath","autodetected":{},"files":[{"filename":"CanRecordMouseMovePath.js","href":"CanRecordMouseMovePath.html#Siesta-Recorder-Role-CanRecordMouseMovePath"}],"members":[{"name":"recordMouseMovePath","tagname":"cfg","owner":"Siesta.Recorder.Role.CanRecordMouseMovePath","id":"cfg-recordMouseMovePath","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-Siesta.Recorder.Role.CanRecordMouseMovePath","short_doc":"A mixin, providing the recording of mouse move path. ...","component":false,"superclasses":[],"subclasses":[],"mixedInto":["Siesta.Recorder.Recorder"],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Mixed into</h4><div class='dependency'><a href='#!/api/Siesta.Recorder.Recorder' rel='Siesta.Recorder.Recorder' class='docClass'>Siesta.Recorder.Recorder</a></div><h4>Files</h4><div class='dependency'><a href='source/CanRecordMouseMovePath.html#Siesta-Recorder-Role-CanRecordMouseMovePath' target='_blank'>CanRecordMouseMovePath.js</a></div></pre><div class='doc-contents'><p>A mixin, providing the recording of mouse move path. This feature solves the problem of interacting\nwith various elements on the page, which appears only after the cursor hovers some other elements.\nTypical example is the resize handler. It normally appears only after the cursor goes over the\nborder element of some UI component. So, to target the resize handler element in some action, we need\nfirst to move cursor to the border element, otherwise resize handler remains invisible.</p>\n\n<p>This recorder feature will make sure cursor goes through the same path as during user interaction,\ntriggering the same hover elements.</p>\n\n<p>Mouse move path is collected in the form, recognized by the <a href=\"#!/api/Siesta.Test.Browser-method-moveCursorAlongPath\" rel=\"Siesta.Test.Browser-method-moveCursorAlongPath\" class=\"docClass\">Siesta.Test.Browser.moveCursorAlongPath</a>\nmethod and the <code>moveCursorAlongPath</code> action is created.</p>\n\n<p>This feature can be enabled/disabled with the <a href=\"#!/api/Siesta.Recorder.Role.CanRecordMouseMovePath-cfg-recordMouseMovePath\" rel=\"Siesta.Recorder.Role.CanRecordMouseMovePath-cfg-recordMouseMovePath\" class=\"docClass\">recordMouseMovePath</a> config option. It will disable\nthe <a href=\"#!/api/Siesta.Recorder.Recorder-cfg-recordPointsOfInterest\" rel=\"Siesta.Recorder.Recorder-cfg-recordPointsOfInterest\" class=\"docClass\">recordPointsOfInterest</a> and\n<a href=\"#!/api/Siesta.Recorder.Recorder-cfg-recordMouseMoveOnIdle\" rel=\"Siesta.Recorder.Recorder-cfg-recordMouseMoveOnIdle\" class=\"docClass\">recordMouseMoveOnIdle</a>\noptions, as it solves the same problem in more general way.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-cfg'>Config options</h3><div class='subsection'><div id='cfg-recordMouseMovePath' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Recorder.Role.CanRecordMouseMovePath'>Siesta.Recorder.Role.CanRecordMouseMovePath</span><br/><a href='source/CanRecordMouseMovePath.html#Siesta-Recorder-Role-CanRecordMouseMovePath-cfg-recordMouseMovePath' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Recorder.Role.CanRecordMouseMovePath-cfg-recordMouseMovePath' class='name expandable'>recordMouseMovePath</a> : Boolean/String<span class=\"signature\"></span></div><div class='description'><div class='short'>Set this option to true to enable recording of path, the user was\nmoving the mouse. ...</div><div class='long'><p>Set this option to <code>true</code> to enable recording of path, the user was\nmoving the mouse. Be prepared, that this option will generate a lot of data in the playback script.</p>\n\n<p>This option can be a <code>Boolean</code> value or a <code>String</code>. A string can be one of <code>coordinate</code> or <code>query</code>.\nThe <code>coordinate</code> will use page coordinates for mouse move path, the <code>query</code> - normal Siesta queries\n(composite, component and CSS) plus offset. The boolean value <code>true</code> corresponds to string <code>coordinate</code>.</p>\n\n<p>Enabling this option will disable the <a href=\"#!/api/Siesta.Recorder.Recorder-cfg-recordPointsOfInterest\" rel=\"Siesta.Recorder.Recorder-cfg-recordPointsOfInterest\" class=\"docClass\">recordPointsOfInterest</a>\nand <a href=\"#!/api/Siesta.Recorder.Recorder-cfg-recordMouseMoveOnIdle\" rel=\"Siesta.Recorder.Recorder-cfg-recordMouseMoveOnIdle\" class=\"docClass\">recordMouseMoveOnIdle</a> options.</p>\n<p>Defaults to: <code>false</code></p></div></div></div></div></div></div></div>","meta":{}});