Ext.data.JsonP.Siesta_Test_Action_Role_HasTarget({"tagname":"class","name":"Siesta.Test.Action.Role.HasTarget","autodetected":{},"files":[{"filename":"HasTarget.js","href":"HasTarget.html#Siesta-Test-Action-Role-HasTarget"}],"members":[{"name":"el","tagname":"cfg","owner":"Siesta.Test.Action.Role.HasTarget","id":"cfg-el","meta":{}},{"name":"offset","tagname":"cfg","owner":"Siesta.Test.Action.Role.HasTarget","id":"cfg-offset","meta":{}},{"name":"options","tagname":"cfg","owner":"Siesta.Test.Action.Role.HasTarget","id":"cfg-options","meta":{}},{"name":"passTargetToNext","tagname":"cfg","owner":"Siesta.Test.Action.Role.HasTarget","id":"cfg-passTargetToNext","meta":{}},{"name":"target","tagname":"cfg","owner":"Siesta.Test.Action.Role.HasTarget","id":"cfg-target","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-Siesta.Test.Action.Role.HasTarget","short_doc":"This is a mixin, allowing the action to have \"target\" attribute, also aliased as \"el\". ...","component":false,"superclasses":[],"subclasses":[],"mixedInto":["Siesta.Test.Action.Click","Siesta.Test.Action.DoubleClick","Siesta.Test.Action.DoubleTap","Siesta.Test.Action.LongPress","Siesta.Test.Action.MonkeyTest","Siesta.Test.Action.MouseDown","Siesta.Test.Action.MouseUp","Siesta.Test.Action.MoveCursor","Siesta.Test.Action.MoveCursorTo","Siesta.Test.Action.Pinch","Siesta.Test.Action.RightClick","Siesta.Test.Action.Swipe","Siesta.Test.Action.Tap","Siesta.Test.Action.Type","Siesta.Test.Action.Wheel"],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Mixed into</h4><div class='dependency'><a href='#!/api/Siesta.Test.Action.Click' rel='Siesta.Test.Action.Click' class='docClass'>Siesta.Test.Action.Click</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.DoubleClick' rel='Siesta.Test.Action.DoubleClick' class='docClass'>Siesta.Test.Action.DoubleClick</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.DoubleTap' rel='Siesta.Test.Action.DoubleTap' class='docClass'>Siesta.Test.Action.DoubleTap</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.LongPress' rel='Siesta.Test.Action.LongPress' class='docClass'>Siesta.Test.Action.LongPress</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.MonkeyTest' rel='Siesta.Test.Action.MonkeyTest' class='docClass'>Siesta.Test.Action.MonkeyTest</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.MouseDown' rel='Siesta.Test.Action.MouseDown' class='docClass'>Siesta.Test.Action.MouseDown</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.MouseUp' rel='Siesta.Test.Action.MouseUp' class='docClass'>Siesta.Test.Action.MouseUp</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.MoveCursor' rel='Siesta.Test.Action.MoveCursor' class='docClass'>Siesta.Test.Action.MoveCursor</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.MoveCursorTo' rel='Siesta.Test.Action.MoveCursorTo' class='docClass'>Siesta.Test.Action.MoveCursorTo</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.Pinch' rel='Siesta.Test.Action.Pinch' class='docClass'>Siesta.Test.Action.Pinch</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.RightClick' rel='Siesta.Test.Action.RightClick' class='docClass'>Siesta.Test.Action.RightClick</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.Swipe' rel='Siesta.Test.Action.Swipe' class='docClass'>Siesta.Test.Action.Swipe</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.Tap' rel='Siesta.Test.Action.Tap' class='docClass'>Siesta.Test.Action.Tap</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.Type' rel='Siesta.Test.Action.Type' class='docClass'>Siesta.Test.Action.Type</a></div><div class='dependency'><a href='#!/api/Siesta.Test.Action.Wheel' rel='Siesta.Test.Action.Wheel' class='docClass'>Siesta.Test.Action.Wheel</a></div><h4>Files</h4><div class='dependency'><a href='source/HasTarget.html#Siesta-Test-Action-Role-HasTarget' target='_blank'>HasTarget.js</a></div></pre><div class='doc-contents'><p>This is a mixin, allowing the action to have \"target\" attribute, also aliased as \"el\". Target will be also passed\nfurther on chain, as the argument after \"next\":</p>\n\n<pre><code>t.chain(\n    {\n        action      : 'click',\n        target      : buttonComp\n    },\n    function (next, buttonComp) {\n        // target is available as 2nd argument\n\n        next()\n    },\n    {\n        action      : 'click',\n        target      : '&gt;&gt;button',\n        offset      : [10, 20]\n    },\n    function (next, buttonComp) {\n        // various queries will be resolved down to Ext.Component instance or DOM element\n\n        next()\n    },\n    ...\n)\n</code></pre>\n\n<p>If needed, this behavior can be disabled with <a href=\"#!/api/Siesta.Test.Action.Role.HasTarget-cfg-passTargetToNext\" rel=\"Siesta.Test.Action.Role.HasTarget-cfg-passTargetToNext\" class=\"docClass\">passTargetToNext</a> option.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-cfg'>Config options</h3><div class='subsection'><div id='cfg-el' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Test.Action.Role.HasTarget'>Siesta.Test.Action.Role.HasTarget</span><br/><a href='source/HasTarget.html#Siesta-Test-Action-Role-HasTarget-cfg-el' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Test.Action.Role.HasTarget-cfg-el' class='name expandable'>el</a> : Object<span class=\"signature\"></span></div><div class='description'><div class='short'><p>An alias for <a href=\"#!/api/Siesta.Test.Action.Role.HasTarget-cfg-target\" rel=\"Siesta.Test.Action.Role.HasTarget-cfg-target\" class=\"docClass\">target</a></p>\n</div><div class='long'><p>An alias for <a href=\"#!/api/Siesta.Test.Action.Role.HasTarget-cfg-target\" rel=\"Siesta.Test.Action.Role.HasTarget-cfg-target\" class=\"docClass\">target</a></p>\n</div></div></div><div id='cfg-offset' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Test.Action.Role.HasTarget'>Siesta.Test.Action.Role.HasTarget</span><br/><a href='source/HasTarget.html#Siesta-Test-Action-Role-HasTarget-cfg-offset' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Test.Action.Role.HasTarget-cfg-offset' class='name expandable'>offset</a> : Array<span class=\"signature\"></span></div><div class='description'><div class='short'>An offset in X, Y coordinates from the targeted element. ...</div><div class='long'><p>An offset in X, Y coordinates from the targeted element. The offset can be expressed in 3 different ways.</p>\n\n<ul>\n<li>Integers             : <code>[10, 20]</code>       -  offset 10px from left, 20px from top</li>\n<li>Percent              : <code>[\"10%\", 20]</code>    -  offset 10% from left, 20px from top</li>\n<li>Percent + offset     : <code>[\"100%-2\", 20]</code> -  offset -2px from right, 20px from top</li>\n</ul>\n\n</div></div></div><div id='cfg-options' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Test.Action.Role.HasTarget'>Siesta.Test.Action.Role.HasTarget</span><br/><a href='source/HasTarget.html#Siesta-Test-Action-Role-HasTarget-cfg-options' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Test.Action.Role.HasTarget-cfg-options' class='name expandable'>options</a> : Object<span class=\"signature\"></span></div><div class='description'><div class='short'>Any options that will be used when simulating the event. ...</div><div class='long'><p>Any options that will be used when simulating the event. For information about possible\nconfig options, please see: <a href=\"https://developer.mozilla.org/en-US/docs/DOM/event.initMouseEvent\">https://developer.mozilla.org/en-US/docs/DOM/event.initMouseEvent</a></p>\n</div></div></div><div id='cfg-passTargetToNext' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Test.Action.Role.HasTarget'>Siesta.Test.Action.Role.HasTarget</span><br/><a href='source/HasTarget.html#Siesta-Test-Action-Role-HasTarget-cfg-passTargetToNext' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Test.Action.Role.HasTarget-cfg-passTargetToNext' class='name expandable'>passTargetToNext</a> : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Whether to pass the target further on chain as the first argument ...</div><div class='long'><p>Whether to pass the target further on chain as the first argument</p>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='cfg-target' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Test.Action.Role.HasTarget'>Siesta.Test.Action.Role.HasTarget</span><br/><a href='source/HasTarget.html#Siesta-Test-Action-Role-HasTarget-cfg-target' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Test.Action.Role.HasTarget-cfg-target' class='name expandable'>target</a> : <a href=\"#!/api/Siesta.Test.ActionTarget\" rel=\"Siesta.Test.ActionTarget\" class=\"docClass\">Siesta.Test.ActionTarget</a>/Function<span class=\"signature\"></span></div><div class='description'><div class='short'>A target for action. ...</div><div class='long'><p>A target for action. See <a href=\"#!/api/Siesta.Test.ActionTarget\" rel=\"Siesta.Test.ActionTarget\" class=\"docClass\">Siesta.Test.ActionTarget</a> for various values that can be provided.</p>\n\n<p><strong>Important.</strong> If the function is provided for this config, it will be called and returning value used as actual target.\nThis is useful, since sometimes target for the action depends from the previous step and\nis not yet available during <code>t.chain</code> call.</p>\n\n<p>For example, you want to click on the button which opens a window and then click on something in the window. Compare:</p>\n\n<pre><code>t.chain(\n    // clicking on button opens the window\n    {\n        action      : 'click',\n        target      : buttonComp\n    },\n    // FRAGILE: `windowComp` could not be rendered yet - `buttonComp` is not yet clicked!\n    {\n        action      : 'click',\n        target      : windowComp.el.down('.clickArea')\n    }\n\n    // MORE ROBUST: taking the \"el\" right before this action starts\n    {\n        action      : 'click',\n        target      : function () {\n            return windowComp.el.down('.clickArea')\n        }\n    }\n)\n</code></pre>\n\n<p>Target will be available in the next step as the 2nd argument. See <a href=\"#!/api/Siesta.Test.Action.Role.HasTarget\" rel=\"Siesta.Test.Action.Role.HasTarget\" class=\"docClass\">Siesta.Test.Action.Role.HasTarget</a></p>\n\n<p>This config option can also be provided as \"el\"</p>\n</div></div></div></div></div></div></div>","meta":{}});